import PropTypes from 'prop-types';
import React, { Suspense, useContext, useEffect, useMemo, useState } from 'react';
import { isLazy } from 'react-is';

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var liteUrl_min = createCommonjsModule(function (module, exports) {
/**
 * lite-url - Small, JS lib that uses regex for parsing a URL into it's component parts.
 * @version v1.0.5
 * @link https://github.com/sadams/lite-url
 * @license BSD-3-Clause
 */
(function () {

  function r(r, n, t) {
    var e = r.split(n),
        o = e.shift();
    return t(o, e.join(n));
  }

  function n(n) {
    var t = {
      hash: "",
      host: "",
      hostname: "",
      origin: "",
      pathname: "",
      protocol: "",
      search: "",
      password: "",
      username: "",
      port: ""
    };
    return r(n, "#", function (n, e) {
      e && (t.hash = e ? "#" + e : ""), r(n, "?", function (n, e) {
        e && (t.search = "?" + e), n && r(n, "//", function (n, e) {
          t.protocol = n, r(e, "/", function (n, e) {
            t.pathname = "/" + (e || ""), (t.protocol || n) && (t.origin = t.protocol + "//" + n), r(n, "@", function (n, e) {
              if (e) {
                var o = n.split(":");
                t.username = o[0], t.password = o[1];
              } else e = n;

              t.host = e, r(e, ":", function (r, n) {
                t.hostname = r, n && (t.port = n);
              });
            });
          });
        });
      });
    }), t.href = t.origin + t.pathname + t.search + t.hash, t;
  }

  function t(r) {
    var n = {},
        t = r.search;

    if (t) {
      t = t.replace(new RegExp("\\?"), "");
      var e = t.split("&");

      for (var o in e) {
        if (e.hasOwnProperty(o) && e[o]) {
          var i = e[o].split("=");
          n[i[0]] = i[1];
        }
      }
    }

    return n;
  }

  function e(r) {
    var e = i[r];
    return "undefined" != typeof e ? e : (e = n(r), e.params = t(e), i[r] = e, e);
  }

  var i = {};
  return e.changeQueryParser = function (r) {
    t = r;
  }, ("undefined" != 'object' && module.exports && (exports = module.exports = e), exports.liteURL = e), e;
}).call(this);
});
var liteUrl_min_1 = liteUrl_min.liteURL;

function regexify(path) {
  return new RegExp(path // escape regex reserved characters
  .replace(/([/.?+])/g, '\\$1') // handle wildcards: *
  .replace(/[.]{0}[*](?![*])/g, '.*?/?') // handle splats: **
  .replace(/[/][.]{0}[*]{2}(?![*])/g, '.*?') // handle query strings: ?foo=bar
  .replace(/\\[?]/, '.*?\\?.*?') // handle optional segments: (/bar)
  .replace(/\(([^)]+)\)/g, '(?:$1)?') // handle dynamic fragments: /:bar
  .replace(/\/:[^/()#?]*/g, '/([^/]*)') + '/?$');
}

var PATH_EXTRACTION_R = /:[^/?#()]*/g;

var isString = function isString(x) {
  return typeof x === 'string';
};

function extractParamsFromPath(path) {
  return isString(path) ? (path.match(PATH_EXTRACTION_R) || []). // remove the leading colon
  map(function (param) {
    return param.slice(1);
  }) : [];
}
function getRouteParamsForURL(route, url) {
  if (!route.params.length) return {};
  var result = url.match(route.test) || [];
  if (result.length) result.shift(); // discard the catchall result

  return result.reduce(function (params, result, index) {
    return params[route.params[index]] = result, params;
  }, {});
}
function processRoute(route) {
  return Object.assign({}, route, {
    params: extractParamsFromPath(route.path),
    test: isString(route.path) ? regexify(route.path) : route.path
  });
}
function valid(validator, url) {
  if (validator instanceof RegExp) {
    return validator.test(url);
  } else if (validator instanceof Function) {
    return validator(url);
  }
}
function getRedirectUrl(redirect, originalUrl) {
  /** Fully-resolved, no work to be done here. */
  if (redirect.includes('://')) return redirect;

  var _LiteURL = new liteUrl_min(originalUrl),
      protocol = _LiteURL.protocol,
      host = _LiteURL.host;
  /**
   * Reconstruct a full URL based on the original with the path
   * switched to the given redirect.
   */


  return "".concat(protocol, "//").concat(host).concat(redirect);
}
function findRoute(routes, url) {
  var route = routes.find(function (route) {
    return valid(route.test, url);
  });

  if (route) {
    if (route.redirect) return findRoute(routes, getRedirectUrl(route.redirect, url));else return {
      route: route,
      url: url
    };
  }

  throw new Error("No valid routes were found for URL ".concat(url, ". Did you forget to define a fallback \"*\" path?"));
}
function parseUrl(url) {
  var parsed = new liteUrl_min(url);
  parsed.query = parsed.search.slice(1).split('&').reduce(function (params, pair) {
    if (pair) {
      var idx = pair.indexOf('=');
      params[pair.slice(0, idx)] = pair.slice(idx + 1);
    }

    return params;
  }, {});
  return parsed;
}
/**
 * Generates an object containing a window.location facsimile
 * for the given URL, any parsed route parameters, and the
 * route itself.
 *
 * @returns {Object} RoutingContext
 */

function createRouteContext(route, url) {
  return {
    location: parseUrl(url),
    params: getRouteParamsForURL(route, url),
    route: route
  };
}
/**
 * Given a set of route definitions and a fully-resolved URL,
 * return a routing context object.
 *
 * If a redirect should be performed, the "redirect" key will be
 * set with the appropriate URL.
 *
 * {
 *     location: object,
 *     params: object,
 *     route: object,
 *     redirect: string?,
 * }
 */

function match(routes, url) {
  var processedRoutes = routes.map(processRoute);
  /**
   * If a redirect occurred, finalUrl may be different from
   * the initial url.
   */

  var _findRoute = findRoute(processedRoutes, url),
      route = _findRoute.route,
      finalUrl = _findRoute.url;

  var ret = Object.assign({}, createRouteContext(route, finalUrl));
  if (finalUrl !== url) ret.redirect = finalUrl;
  return ret;
}
/**
 * A client-side method for programmatically updating the routing state.
 *
 * Accepts a new url (absolute or relative) and an optional second boolean
 * parameter controlling if a new browser history entry should be created.
 *
 * If you want to change the routing state on server, just pass a new url to
 * the <Router> component.
 */

function route(url) {
  var addNewHistoryEntry = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  history[addNewHistoryEntry ? 'pushState' : 'replaceState']({}, '', url); // this is what triggers the routing to update

  window.dispatchEvent(new Event('popstate'));
}

var ButtermilkContext = /*#__PURE__*/React.createContext();
var BROWSER = typeof window !== 'undefined';

var NOOP = function NOOP() {};
/**
 * The gist of Buttermilk's router is that it acts like a controlled component when used
 * server-side (driven by `props.url`) and an uncontrolled one client-side (driven by the
 * value of `window.location.href` and intercepted navigation events.)
 *
 * In the browser, use either a <Link> component or the route() method to change routes.
 * The router will also automatically pick up popstate events caused by user-driven browser
 * navigation (forward, back buttons, etc.)
 */

function Router(props) {
  if (!BROWSER && !props.url) {
    throw new Error('props.url is required for non-browser environments');
  } // this is entirely derived from props so useMemo works fine


  var routes = useMemo(function () {
    return processRoutes(props.routes);
  }, [props.routes]);

  var _useState = useState(getStateUpdateForUrl(routes, props.url || window.location.href, null)),
      _useState2 = _slicedToArray(_useState, 2),
      routingState = _useState2[0],
      updateRoutingState = _useState2[1]; // an internal redirect may happen in getStateUpdateForUrl -> findRoute, so we'll use the final returned url


  var _useState3 = useState(routingState.url),
      _useState4 = _slicedToArray(_useState3, 2),
      url = _useState4[0],
      updateUrl = _useState4[1]; // this effect triggers the update flow in a controlled Router or SSR use case


  useEffect(function () {
    return updateUrl(props.url || routingState.url);
  }, [props.url]);
  useEffect(function () {
    props.routerDidInitialize(routingState.routingProps);

    function handleLocationChange() {
      updateUrl(window.location.href);
    }

    window.addEventListener('popstate', handleLocationChange);
    window.addEventListener('hashchange', handleLocationChange);
    return function () {
      window.removeEventListener('popstate', handleLocationChange);
      window.removeEventListener('hashchange', handleLocationChange);
    };
  }, []);
  useEffect(function () {
    var _findRoute = findRoute(routes, url),
        nextRoute = _findRoute.route,
        nextUrl = _findRoute.url;

    if (nextRoute !== routingState.activeRoute || nextUrl !== routingState.url) {
      var nextRoutingProps = createRouteContext(nextRoute, nextUrl);
      var result = props.routeWillChange(routingState.routingProps, nextRoutingProps);

      var finish = function finish() {
        updateRoutingState(getStateUpdateForUrl(routes, nextUrl, routingState.routingProps));
        updateUrl(nextUrl);
      };

      if (result === false) return;else if (result instanceof Promise) result.then(finish, NOOP);else finish();
    }
  }, [routes, url]);
  useEffect(function () {
    if (routingState.prevRoutingProps) props.routeDidChange(routingState.routingProps, routingState.prevRoutingProps);
  }, [routingState.routingProps.route, routingState.routingProps.location]);
  var Renderable = routingState.children;
  var children = ! /*#__PURE__*/React.isValidElement(Renderable) ? /*#__PURE__*/React.createElement(Renderable, routingState.routingProps) : Renderable;
  return /*#__PURE__*/React.createElement(ButtermilkContext.Provider, {
    value: routingState.routingProps
  }, /*#__PURE__*/React.createElement(props.outerComponent, routingState.routingProps, isLazy(Renderable) ? /*#__PURE__*/React.createElement(Suspense, {
    fallback: /*#__PURE__*/React.createElement(props.loadingComponent, null)
  }, children) : children));
}
Router.propTypes = {
  /**
   * Provide a spinner or something to look at while the promise
   * is in flight if using async routes.
   */
  loadingComponent: PropTypes.oneOfType([PropTypes.func, PropTypes.string]),

  /**
   * An optional app runtime component. Think of it like the "shell" of your
   * app, so perhaps the outer container, nav bar, etc. You'll probably want to
   * put any "Provider" type components here that are intended to wrap your
   * whole application.
   */
  outerComponent: PropTypes.oneOfType([PropTypes.func, PropTypes.string]),
  routes: PropTypes.arrayOf(PropTypes.shape({
    /**
     * A RegExp, string, or function accepting the URL as
     * an argument and returning a boolean if valid.
     */
    path: PropTypes.oneOfType([PropTypes.instanceOf(RegExp), PropTypes.string, PropTypes.func]).isRequired,

    /**
     * A string URL path to a different route. If this is given,
     * then "render" is not required.
     */
    redirect: PropTypes.string,

    /**
     * A function that returns one of the following:
     *
     * 1. JSX.
     * 2. A React component class.
     * 3. A promise resolving to JSX or a React component class.
     */
    render: PropTypes.func
  })).isRequired,

  /**
   * A hook for reacting to an impending route transition. Accepts a promise
   * and will pause the route transition until the promise is resolved. Return
   * false or reject a given promise to abort the routing update.
   *
   * Provides currentRouting and nextRouting as arguments.
   */
  routeWillChange: PropTypes.func,

  /**
   * A hook for reacting to a completed route transition. It might be used
   * for synchronizing some global state if desired.
   *
   * Provides currentRouting and previousRouting as arguments.
   */
  routeDidChange: PropTypes.func,

  /**
   * A hook for synchronizing initial routing state.
   *
   * Providers initialRouting as an argument.
   */
  routerDidInitialize: PropTypes.func,

  /**
   * The initial URL to be used for processing, falls back to
   * window.location.href for non-SSR. Required for environments without
   * browser navigation eventing.
   */
  url: PropTypes.string
};
Router.defaultProps = {
  loadingComponent: 'div',
  outerComponent: 'div',
  routeDidChange: NOOP,
  routeWillChange: NOOP,
  routerDidInitialize: NOOP,
  url: ''
};

function getStateUpdateForUrl(routes, url, prevRoutingProps) {
  var result = findRoute(routes, url);
  var nextRoutingProps = createRouteContext(result.route, result.url);
  return {
    activeRoute: result.route,
    children: result.route.render(nextRoutingProps),
    prevRoutingProps: prevRoutingProps,
    routes: routes,
    routingProps: nextRoutingProps,
    url: result.url
  };
}

function processRoutes(routes) {

  return routes.map(processRoute);
}
/**
 * Allows for obtaining routingState with the `useContext` hook.
 */


var RoutingContext = ButtermilkContext;
/**
 * Compose it like this:
 *
 * <RoutingState>
 *   {({ location, params, route }) => {
 *      return <div>{location.pathname}</div>
 *   }}
 * </RoutingState>
 */

var RoutingState = ButtermilkContext.Consumer;
/**
 * A polymorphic anchor link component. On click/tap/enter if the destination
 * matches a value route, the routing context will be modified without
 * reloading the page. Otherwise, it will act like a normal anchor link.
 *
 * If something other than an anchor tag is specified via props.as, a
 * [role="link"] attribute will be added for basic assistive technology support.
 *
 * Adds [data-active] if the given href matches the active route.
 */

var Link = /*#__PURE__*/React.forwardRef(function ButtermilkLink(props, ref) {
  var routingState = useContext(ButtermilkContext);
  return /*#__PURE__*/React.createElement(props.as || 'a', Object.assign({}, props, {
    'data-active': valid(routingState.route.test, props.href) ? '' : undefined,
    'data-href': props.href,
    as: undefined,
    href: shouldRenderAnchorProps(props) ? props.href : undefined,
    ref: ref,
    role: shouldRenderRole(props) ? 'link' : undefined,
    onClick: handleNavigationIntent,
    tabIndex: props.tabIndex || 0,
    target: shouldRenderAnchorProps(props) ? props.target : undefined
  }));
});
Link.propTypes = {
  /**
   * An HTML tag name or valid ReactComponent class to be rendered. Must
   * be compatible with React.createElement.
   *
   * Defaults to an anchor "a" tag.
   */
  as: PropTypes.oneOfType([PropTypes.func, PropTypes.string]),

  /**
   * A valid relative or absolute URL string.
   */
  href: PropTypes.string.isRequired,

  /**
   * Any valid value of the anchor tag "target" attribute.
   *
   * See: https://developer.mozilla.org/en-US/docs/Web/HTML/Element/a#attr-target
   */
  target: PropTypes.string
};

function shouldRenderAnchorProps(props) {
  return props.as === 'a' || typeof props.as !== 'string';
}

function shouldRenderRole(props) {
  return props.as !== 'a';
}

function handleNavigationIntent(event) {
  event.preventDefault();
  event.stopPropagation();
  var href = event.target.getAttribute('data-href');

  if (event.metaKey || event.target.getAttribute('target') === '_blank') {
    window.open(href);
  } else {
    route(href);
  }
}

export { match, route, Router, RoutingContext, RoutingState, Link };
//# sourceMappingURL=es.js.map
